CF896C Willem, Chtholly and Seniorious 题解
题目链接:CF 或者 洛谷
比较经典的题目
看到存在随机数据以及区间赋值先别急,我们发现第四个操作是很难办的,第四个操作貌似只有暴力才好做。这个时候我们可以考虑使用珂朵莉树来做,这题也是珂朵莉树的出处。使用平衡树去写珂朵莉树的话,那么随机数据下,连续段的期望为 \(\log{n}\) 个,所以使用平衡树进行二分查找分裂的复杂度为 \(\log{\log{n}}\)。加和覆盖都是基本的珂朵莉树操作,直接暴力遍历期望的 \(\log{n}\) 个段就行,复杂度为 \(O(\log{n})\)。查询区间第 \(k\) 大,由于段数并不多,我们可以进行排序以后然后逐段寻找答案,类似可持久化线段树二分的过程,排序复杂度为 \(O(\log{\log{n}})\),然后再暴力逐段寻找答案 \(O(\log{n})\)。最后一个操作就是较为复杂的,对于一个段的贡献来说,显然为 \(cnt \times (val^x \bmod y)\)。而 \(cnt=r-l+1\),直接快速幂即可。复杂度显然为:\(O(\log{n} \times \log{x}) \sim O(\log^2{n})\)。
参照代码
#include <bits/stdc++.h>
// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
// #define isPbdsFile
#ifdef isPbdsFile
#include <bits/extc++.h>
#else
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/trie_policy.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/list_update_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/exception.hpp>
#include <ext/rope>
#endif
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> tii;
typedef tuple<ll, ll, ll> tll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef __int128 i128;
#define hash1 unordered_map
#define hash2 gp_hash_table
#define hash3 cc_hash_table
#define stdHeap std::priority_queue
#define pbdsHeap __gnu_pbds::priority_queue
#define sortArr(a, n) sort(a+1,a+n+1)
#define all(v) v.begin(),v.end()
#define yes cout<<"YES"
#define no cout<<"NO"
#define Spider ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define MyFile freopen("..\\input.txt", "r", stdin),freopen("..\\output.txt", "w", stdout);
#define forn(i, a, b) for(int i = a; i <= b; i++)
#define forv(i, a, b) for(int i=a;i>=b;i--)
#define ls(x) (x<<1)
#define rs(x) (x<<1|1)
#define endl '\n'
//用于Miller-Rabin
[[maybe_unused]] static int Prime_Number[13] = {0, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};
template <typename T>
int disc(T* a, int n)
{
return unique(a + 1, a + n + 1) - (a + 1);
}
template <typename T>
T lowBit(T x)
{
return x & -x;
}
template <typename T>
T Rand(T l, T r)
{
static mt19937 Rand(time(nullptr));
uniform_int_distribution<T> dis(l, r);
return dis(Rand);
}
template <typename T1, typename T2>
T1 modt(T1 a, T2 b)
{
return (a % b + b) % b;
}
template <typename T1, typename T2, typename T3>
T1 qPow(T1 a, T2 b, T3 c)
{
a %= c;
T1 ans = 1;
for (; b; b >>= 1, (a *= a) %= c)if (b & 1)(ans *= a) %= c;
return modt(ans, c);
}
template <typename T>
void read(T& x)
{
x = 0;
T sign = 1;
char ch = getchar();
while (!isdigit(ch))
{
if (ch == '-')sign = -1;
ch = getchar();
}
while (isdigit(ch))
{
x = (x << 3) + (x << 1) + (ch ^ 48);
ch = getchar();
}
x *= sign;
}
template <typename T, typename... U>
void read(T& x, U&... y)
{
read(x);
read(y...);
}
template <typename T>
void write(T x)
{
if (typeid(x) == typeid(char))return;
if (x < 0)x = -x, putchar('-');
if (x > 9)write(x / 10);
putchar(x % 10 ^ 48);
}
template <typename C, typename T, typename... U>
void write(C c, T x, U... y)
{
write(x), putchar(c);
write(c, y...);
}
template <typename T11, typename T22, typename T33>
struct T3
{
T11 one;
T22 tow;
T33 three;
bool operator<(const T3 other) const
{
if (one == other.one)
{
if (tow == other.tow)return three < other.three;
return tow < other.tow;
}
return one < other.one;
}
T3() { one = tow = three = 0; }
T3(T11 one, T22 tow, T33 three) : one(one), tow(tow), three(three)
{
}
};
template <typename T1, typename T2>
void uMax(T1& x, T2 y)
{
if (x < y)x = y;
}
template <typename T1, typename T2>
void uMin(T1& x, T2 y)
{
if (x > y)x = y;
}
constexpr int MOD = 1e9 + 7;
ll n, m, seed, vMax;
inline ll rnd()
{
const ll ans = seed;
seed = (seed * 7 + 13) % MOD;
return ans;
}
struct ODT
{
int l, r;
mutable ll val;
bool operator<(const ODT& other) const
{
return l < other.l;
}
};
set<ODT> node;
typedef set<ODT>::iterator iter;
inline iter split(const int pos)
{
auto it = node.lower_bound(ODT(pos, 0, 0));
if (it != node.end() and it->l == pos)return it;
--it;
if (it->r < pos)return node.end();
auto [l,r,val] = *it;
node.erase(it), node.insert(ODT(l, pos - 1, val));
return node.insert(ODT(pos, r, val)).first;
}
inline void add(const int l, const int r, const int val)
{
auto itr = split(r + 1), itl = split(l);
for (auto it = itl; it != itr; ++it)it->val += val;
}
inline void assign(const int l, const int r, const int val)
{
auto itr = split(r + 1), itl = split(l);
node.erase(itl, itr), node.insert(ODT(l, r, val));
}
inline ll queryKth(const int l, const int r, int k)
{
auto itr = split(r + 1), itl = split(l);
vector<pll> curr;
for (auto it = itl; it != itr; ++it)curr.emplace_back(it->val, it->r - it->l + 1);
sort(all(curr));
for (const auto [v,siz] : curr)
{
if (siz < k)k -= siz;
else return v;
}
return 0;
}
inline ll querySum(const int l, const int r, const int x, const int y)
{
auto itr = split(r + 1), itl = split(l);
ll ans = 0;
for (auto it = itl; it != itr; ++it)
{
auto [l,r,val] = *it;
ans = (ans + (r - l + 1) * qPow(val, x, y)) % y;
}
return ans;
}
inline void solve()
{
cin >> n >> m >> seed >> vMax;
forn(i, 1, n)node.insert(ODT(i, i, rnd() % vMax + 1));
while (m--)
{
const int op = rnd() % 4 + 1;
int l = rnd() % n + 1;
int r = rnd() % n + 1;
if (l > r)swap(l, r);
int x, y = 0;
if (op == 3)x = rnd() % (r - l + 1) + 1;
else x = rnd() % vMax + 1;
if (op == 4)y = rnd() % vMax + 1;
if (op == 1)add(l, r, x);
else if (op == 2)assign(l, r, x);
else if (op == 3)cout << queryKth(l, r, x) << endl;
else cout << querySum(l, r, x, y) << endl;
}
}
signed int main()
{
// MyFile
Spider
//------------------------------------------------------
// clock_t start = clock();
int test = 1;
// read(test);
// cin >> test;
forn(i, 1, test)solve();
// while (cin >> n, n)solve();
// while (cin >> test)solve();
// clock_t end = clock();
// cerr << "time = " << double(end - start) / CLOCKS_PER_SEC << "s" << endl;
}